var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { Module, createRequire } from "module";
import path from "path";
import vm from "vm";
import { nanoid } from "nanoid";
import url from "url";
import { transform, transformSync } from "esbuild";
const isInESModuleScope = () => {
  try {
    return module === void 0;
  } catch {
    return true;
  }
};
const isVMModuleAvailable = () => vm.Module !== void 0;
const fileURLToPath = (value) => value.startsWith("file://") ? url.fileURLToPath(value) : value;
const FUNCTION_NAMES = [
  "getCallerDirname",
  "requireFromString",
  "importFromString",
  "importFromStringSync",
  "processTicksAndRejections"
];
const getCallerDirname = () => {
  const _prepareStackTrace = Error.prepareStackTrace;
  Error.prepareStackTrace = (_err, stackTraces) => stackTraces;
  const callSites = new Error().stack.filter((callSite) => {
    const functionName = callSite.getFunctionName();
    return functionName === null || !FUNCTION_NAMES.includes(functionName);
  });
  Error.prepareStackTrace = _prepareStackTrace;
  const callerFilename = callSites[0].getFileName();
  return path.dirname(callerFilename !== null ? fileURLToPath(callerFilename) : process.argv[1]);
};
const resolveModuleSpecifier = (specifier, dirname) => {
  const specifierPath = fileURLToPath(specifier);
  return specifierPath.startsWith(".") || path.isAbsolute(specifierPath) ? path.resolve(dirname, specifierPath) : specifier;
};
const requireFromString = (code, { dirname = getCallerDirname(), globals } = {}) => {
  var _a;
  const moduleFilename = path.join(dirname, `${nanoid()}.js`);
  const mainModule = isInESModuleScope() ? void 0 : require.main;
  const contextModule = new Module(moduleFilename, mainModule);
  contextModule.filename = moduleFilename;
  contextModule.path = dirname;
  contextModule.paths = (_a = mainModule == null ? void 0 : mainModule.paths) != null ? _a : [];
  contextModule.require = createRequire(moduleFilename);
  vm.runInNewContext(code, __spreadValues({
    __dirname: contextModule.path,
    __filename: contextModule.filename,
    exports: contextModule.exports,
    module: contextModule,
    require: contextModule.require
  }, globals), {
    async importModuleDynamically(specifier) {
      return await import(resolveModuleSpecifier(specifier, contextModule.path));
    }
  });
  contextModule.loaded = true;
  return contextModule.exports;
};
const IMPORT_META_URL_SHIM = "var import_meta_url = require('url').pathToFileURL(__filename).toString();";
const IMPORT_META_RESOLVE_SHIM = `var import_meta_resolve = () => {
  throw new Error(
    \`'import.meta.resolve' is not supported
Use asynchronous function 'importFromString' and enable '--experimental-vm-modules' CLI option.
Or use 'transformOptions' to include a polyfill. See https://github.com/evanw/esbuild/issues/1492#issuecomment-893144483 as an example.\`
  );
};`;
const getCommonJS = (transformOptions) => {
  return __spreadProps(__spreadValues({}, transformOptions), {
    banner: `${(transformOptions == null ? void 0 : transformOptions.banner) === void 0 ? "" : `${transformOptions.banner}
`}${IMPORT_META_URL_SHIM}
${IMPORT_META_RESOLVE_SHIM}`,
    define: __spreadValues({
      "import.meta.url": "import_meta_url",
      "import.meta.resolve": "import_meta_resolve"
    }, transformOptions == null ? void 0 : transformOptions.define),
    format: "cjs"
  });
};
const ERR_REQUIRE_ESM = "ERR_REQUIRE_ESM";
const importFromString = async (code, { dirname = getCallerDirname(), globals, transformOptions } = {}) => {
  if (!isVMModuleAvailable()) {
    const { code: transformedCode2 } = await transform(code, getCommonJS(transformOptions));
    try {
      return requireFromString(transformedCode2, { dirname, globals });
    } catch (err) {
      if (err.code === ERR_REQUIRE_ESM) {
        throw new Error(`'import' statement of ES modules is not supported
Enable '--experimental-vm-modules' CLI option or replace it with dynamic 'import()' expression.`);
      }
      throw err;
    }
  }
  const { code: transformedCode = void 0 } = transformOptions === void 0 ? {} : await transform(code, __spreadValues({
    format: "esm"
  }, transformOptions));
  const moduleFilename = path.join(dirname, `${nanoid()}.js`);
  const context = vm.createContext(__spreadValues({
    __IMPORTS__: {}
  }, globals));
  const vmModule = new vm.SourceTextModule(transformedCode != null ? transformedCode : code, {
    identifier: moduleFilename,
    context,
    initializeImportMeta(meta) {
      meta.url = moduleFilename;
    },
    async importModuleDynamically(specifier) {
      return await import(resolveModuleSpecifier(specifier, dirname));
    }
  });
  const linker = async (specifier) => {
    const resolvedSpecifier = resolveModuleSpecifier(specifier, dirname);
    const targetModule = await import(resolvedSpecifier);
    context.__IMPORTS__[specifier] = targetModule;
    const exportedNames = Object.getOwnPropertyNames(targetModule);
    const targetModuleContent = `${exportedNames.includes("default") ? `export default __IMPORTS__['${specifier}'].default;
` : ""}export const { ${exportedNames.filter((exportedName) => exportedName !== "default").join(", ")} } = __IMPORTS__['${specifier}'];`;
    return new vm.SourceTextModule(targetModuleContent, {
      identifier: resolvedSpecifier,
      context
    });
  };
  await vmModule.link(linker);
  await vmModule.evaluate();
  return vmModule.namespace;
};
const importFromStringSync = (code, { dirname = getCallerDirname(), globals, transformOptions } = {}) => {
  const { code: transformedCode } = transformSync(code, getCommonJS(transformOptions));
  try {
    return requireFromString(transformedCode, { dirname, globals });
  } catch (err) {
    if (err.code === ERR_REQUIRE_ESM) {
      throw new Error(`'import' statement of ES modules is not supported
Use asynchronous function 'importFromString' instead or replace it with dynamic 'import()' expression.`);
    }
    throw err;
  }
};
export { importFromString, importFromStringSync, requireFromString };
